/*	blinking_led.c

		      *

		      *	This code blinks the LED D2 on PORTA PIN0 i.e PA0 of the AVR board.

		      *

		      *	The LED D2 is connected to PA0 on the Atmel chip, and is wired so that

		      *	it will be ON when the output is high and OFF when the output is low.

		      *

		      *	The "special function registers" used in this program are:

		      *		DDRA -- Port A Data Direction Register

		      *			A high (1) value indicates output, low (0) is input.

		      *			We set the 0th bit in DDRA to configure the PA0 pin as output pin.

		      *		PORTA -- Port A Data Register

		      *			This is used to set the output value for each of the

		      *			eight port A pins. 

		      *	WaitMs() is used to produce a delay.

	        */

		    
 

		    
#include <avr/io.h>

		      #include <avr/interrupt.h>

		    
 

		    
/*Macros definition*/

		      #define BIT(x)	(1 << (x))			//Set a particular bit mask

		      #define CHECKBIT(x,b) x&b			//Checks bit status

		      #define SETBIT(x,b) x|=b;			//Sets the particular bit

		      #define CLEARBIT(x,b) x&=~b;		//Sets the particular bit

		      #define TOGGLEBIT(x,b) x^=b;		//Toggles the particular bit

		    
 

		    
void WaitMs(unsigned int ms);

		    
 

		    
int main(void)
{

		      SETBIT(DDRA,BIT(0))			//Sets Direction of 6th pin of port B as output
			  //CLEARBIT(DDRD,BIT(0))

              

		      while(1)

		      {

		      //TODO:: Please write your application code 

		      SETBIT(PORTA,BIT(0))	//Sets PORTB6 as high i.e. turn on led

		      WaitMs(20);			//delay for 200ms(0.2s)

		      CLEARBIT(PORTA,BIT(0))	//Clears PORTB6(PB6 pin goes low) i.e turn off led

		      WaitMs(20);			//delay for 200ms(0.2s)

		      }

              

		      return 0;

		      }

		    
 

		    
/* waits (pauses) for ms milliseconds (assumes clock at 16MHz) */

		      void WaitMs(unsigned int ms)

		      {

		      int i;

		    
 while (ms-- > 0)

		      {

		      /* 16380 (16k) clock cycles for 1ms; each time through loop

		      is 5 cycles (for loop control) */

		      for (i = 0; i < 1000; ++i)

		      {

		      } 

  

		      }

		      }
